
#include <amxmodx> 
#include <fakemeta> 

new const Version[] = "1.1";

const TimeleftStringLen = 100
const NextmapLen = 60

new TimeleftString[TimeleftStringLen+1]
			
new Timelimit;
new Nextmap; 

new PreText
new PostText
 
public plugin_init() 
{ 
	register_plugin("Timeleft as Game Description", "joaquimandrade" , Version); 
	register_forward( FM_GetGameDescription, "getGameDescription" );  
	
	Timelimit = get_cvar_pointer("mp_timelimit")
	Nextmap = get_cvar_pointer("amx_nextmap")
	
	PreText = register_cvar("gameDescription_pre","")
	PostText = register_cvar("gameDescription_post","")
	
	register_cvar("TimeleftGameDescription_version",Version,FCVAR_SERVER|FCVAR_SPONLY);
	
	register_dictionary("timeleft.txt")
} 
 
public getGameDescription() 
{ 
	get_pcvar_string(PreText,TimeleftString,TimeleftStringLen);
	
	new len = strlen(TimeleftString);
	
	if (get_pcvar_float(Timelimit))
	{
		new timeleft = get_timeleft()
		
		if(timeleft / 60)
		{
			len += formatex(TimeleftString[len], TimeleftStringLen - len,"%L: %d:%02d", LANG_PLAYER, "TIME_LEFT", (timeleft / 60), (timeleft % 60))
		}
		else
		{
			static nextmapName[NextmapLen+1]
			get_pcvar_string(Nextmap,nextmapName,NextmapLen)
			
			if(timeleft % 60)
			{
				len += formatex(TimeleftString[len], TimeleftStringLen - len,"%L: %d:%02d ( %L %s )", LANG_PLAYER, "TIME_LEFT", (timeleft / 60), (timeleft % 60), LANG_PLAYER, "NEXT_MAP", nextmapName)
			}
			else
			{
				len += formatex(TimeleftString[len], TimeleftStringLen - len,"%L %s", LANG_PLAYER, "NEXT_MAP", nextmapName)
			}
		}
	}
	else
	{
		len	+= formatex(TimeleftString[len], TimeleftStringLen - len, "%L", LANG_PLAYER, "NO_T_LIMIT")
	}
	
	get_pcvar_string(PostText,TimeleftString[len],TimeleftStringLen - len);
	
	forward_return(FMV_STRING,TimeleftString); 
	
	return FMRES_SUPERCEDE; 
}